

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;

import org.junit.Test;
public class WebcatPhotographTests {	

    @Test(timeout=100)
    public void testConstructor() {
        Photograph b = new Photograph("mypic.jpg", "Grand Canyon", "2019-02-13", 2);
        assertEquals("Photograph constructor (or getter) failed for caption", "Grand Canyon", b.getCaption());
        assertEquals("Photograph constructor (or getter) failed for filename", "mypic.jpg", b.getFilename());
        assertEquals("Photograph constructor (or getter) failed for dateTaken", "2019-02-13", b.getDateTaken());
        assertEquals("Photograph constructor (or getter) failed for rating", 2, b.getRating());
    }
    @Test(timeout=100)
    public void testConstructorOriginal() {
        Photograph b = new Photograph("mypic.jpg", "Grand Canyon");
        assertEquals("Original photograph constructor (or getter) failed for caption", "Grand Canyon", b.getCaption());
        assertEquals("Original photograph constructor (or getter) failed for filename", "mypic.jpg", b.getFilename());
    }

    @Test(timeout=100)
    public void equalsType() throws Exception {
        try {
            Photograph.class.getDeclaredMethod("equals", Object.class);
        } catch (NoSuchMethodException e) {
            fail("Photograph equals method not specified correctly.");
        } catch (Exception e) {
            throw e;
        }
    }

    @Test(timeout=100)
    public void equalsSame() {
        Photograph b = new Photograph("mypic3.jpg", "Grand Canyon 2", "2019-02-13", 3);
        assertTrue("Photograph.equals() failed: Not symmetric", b.equals(b));
    }
    @Test(timeout=100)
    public void equalsSimilar() {
        Photograph b = new Photograph("mypic3.jpg", "Grand Canyon 3", "2019-02-13", 5);
        Photograph c = new Photograph("mypic3.jpg", "Grand Canyon 3", "2019-02-13", 5);
        assertTrue("Photograph.equals() failed: Two photographs with same caption and file name not equal", b.equals(c));
    }
    @Test(timeout=100)
    public void equalsDifferentTypes() throws Exception {
        try {
            Photograph b = new Photograph("yosemite.png", "Family Vacation");
            assertFalse("Photograph.equals() failed: Compared Photograph to Integer", b.equals(42));
        } catch (ClassCastException e) {
            fail("Photograph.equals() failed: Casting a non-Photograph to a Photograph");
        } catch (Exception e) {
            throw e;
        }
    }

    @Test(timeout=100)
    public void testRatingMutator() {
        Photograph b = new Photograph("mypic.jpg", "Grand Canyon", "2019-02-13", 2);
        assertEquals("Photograph constructor (or getter) failed for rating", 2, b.getRating());
        b.setRating(3);
        assertEquals("Photograph rating mutator (or getter) failed", 3, b.getRating());
    }
    @Test(timeout=100)
    public void testRatingMutatorEdge1() {
        Photograph b = new Photograph("mypic.jpg", "Grand Canyon", "2019-02-13", 2);
        assertEquals("Photograph constructor (or getter) failed for rating", 2, b.getRating());
        b.setRating(0);
        assertEquals("Photograph rating mutator (or getter) failed (edge case)", 0, b.getRating());
        b.setRating(5);
        assertEquals("Photograph rating mutator (or getter) failed (edge case)", 5, b.getRating());
    }
    @Test(timeout=100)
    public void testRatingMutatorEdge2() {
        Photograph b = new Photograph("mypic.jpg", "Grand Canyon", "2019-02-13", 2);
        assertEquals("Photograph constructor (or getter) failed for rating", 2, b.getRating());
        b.setRating(-5);
        assertEquals("Photograph rating mutator (or getter) failed (edge case)", 2, b.getRating());
        b.setRating(6);
        assertEquals("Photograph rating mutator (or getter) failed (edge case)", 2, b.getRating());
    }

    @Test(timeout=100)
    public void testToString() {
        Photograph b = new Photograph("mypic.jpg", "Grand Canyon", "2019-02-13", 2);
        String s = b.toString();
        assertTrue("Photograph.toString must have caption", s.contains("Grand Canyon"));
        assertTrue("Photograph.toString must have filename", s.contains("mypic.jpg"));
    }

}
