import static org.junit.Assert.*;

import org.junit.Test;

public class WebcatComparingTests {
    
    private CompareByRating byRating = new CompareByRating();
    private CompareByCaption byCaption = new CompareByCaption();

    @Test
    public void testPhotographCompare() {
        Photograph b = new Photograph("mypic3.jpg", "Grand Canyon 3", "2019-02-13", 5);
        Photograph c = new Photograph("mypic3.jpg", "Grand Canyon 3", "2019-02-13", 5);
        assertEquals("Photograph compareTo didn't say two photos were equal (return 0)", 0, b.compareTo(b));
        assertEquals("Photograph compareTo didn't say two photos were equal (return 0)", 0, b.compareTo(c));
    }
    
    @Test
    public void testPhotographCompare2() {
        Photograph b = new Photograph("mypic3.jpg", "Grand Canyon 3", "2018-02-13", 5);
        Photograph c = new Photograph("mypic3.jpg", "Grand Canyon 3", "2019-02-13", 5);
        assertTrue("Photograph compareTo didn't compare photos properly by date", b.compareTo(c) < 0);
        assertTrue("Photograph compareTo didn't compare photos properly by date", c.compareTo(b) > 0);
    }
    
    @Test
    public void testPhotographCompare3() {
        Photograph b = new Photograph("mypic3.jpg", "Grand Canyon 3", "2017-12-13", 5);
        Photograph c = new Photograph("mypic3.jpg", "Grand Canyon 3", "2018-02-13", 5);
        assertTrue("Photograph compareTo didn't compare photos properly by date", b.compareTo(c) < 0);
        assertTrue("Photograph compareTo didn't compare photos properly by date", c.compareTo(b) > 0);
    }
    
    @Test
    public void testPhotographCompare4() {
        Photograph b = new Photograph("mypic3.jpg", "Grand Canyon 3", "2018-01-13", 5);
        Photograph c = new Photograph("mypic3.jpg", "Grand Canyon 3", "2018-04-11", 5);
        assertTrue("Photograph compareTo didn't compare photos properly by date", b.compareTo(c) < 0);
        assertTrue("Photograph compareTo didn't compare photos properly by date", c.compareTo(b) > 0);
    }
    
    @Test
    public void testPhotographCompare5() {
        Photograph b = new Photograph("mypic3.jpg", "Grand Canyon 1", "2018-01-13", 5);
        Photograph c = new Photograph("mypic3.jpg", "Grand Canyon 3", "2018-01-13", 5);
        assertTrue("Photograph compareTo didn't compare photos properly by caption if dates equal", b.compareTo(c) < 0);
        assertTrue("Photograph compareTo didn't compare photos properly by caption if dates equal", c.compareTo(b) > 0);
    }
    
    
    @Test
    public void testPhotographCompare6() {
        Photograph b = new Photograph("mypic3.jpg", "A great photo!", "2018-01-13", 5);
        Photograph c = new Photograph("mypic3.jpg", "Grand Canyon 3", "2018-01-13", 5);
        assertTrue("Photograph compareTo didn't compare photos properly by caption if dates equal", b.compareTo(c) < 0);
        assertTrue("Photograph compareTo didn't compare photos properly by caption if dates equal", c.compareTo(b) > 0);
    }
    
    @Test
    public void testCompareByRating() {
        Photograph b = new Photograph("mypic3.jpg", "Grand Canyon 3", "2019-02-13", 3);
        Photograph c = new Photograph("mypic3.jpg", "Grand Canyon 3", "2019-02-13", 3);
        assertEquals("CompareByRating compare() didn't say two photos were equal (return 0)", 0, byRating.compare(b,b));
        assertEquals("CompareByRating compare() didn't say two photos were equal (return 0)", 0, byRating.compare(b, c));
    }
    
    @Test
    public void testCompareByRating2() {
        Photograph b = new Photograph("mypic3.jpg", "Grand Canyon 3", "2018-02-13", 5);
        Photograph c = new Photograph("mypic3.jpg", "Grand Canyon 3", "2019-02-13", 2);
        assertTrue("CompareByRating compare() didn't compare photos properly by rating", byRating.compare(b,c) < 0);
        assertTrue("CompareByRating compare() didn't compare photos properly by rating", byRating.compare(c,b) > 0);
    }
    
    @Test
    public void testCompareByRating3() {
        Photograph b = new Photograph("mypic3.jpg", "Grand Canyon 3", "2017-12-13", 1);
        Photograph c = new Photograph("mypic3.jpg", "Grand Canyon 3", "2018-02-13", 0);
        assertTrue("CompareByRating compare() didn't compare photos properly by rating", byRating.compare(b,c) < 0);
        assertTrue("CompareByRating compare() didn't compare photos properly by rating", byRating.compare(c,b) > 0);
    }
    
    @Test
    public void testCompareByRating5() {
        Photograph b = new Photograph("mypic3.jpg", "Grand Canyon 1", "2018-01-13", 5);
        Photograph c = new Photograph("mypic3.jpg", "Grand Canyon 3", "2018-01-13", 5);
        assertTrue("CompareByRating compare() didn't compare photos properly by caption if rating equal", byRating.compare(b,c) < 0);
        assertTrue("CompareByRating compare() didn't compare photos properly by caption if rating equal", byRating.compare(c,b) > 0);
    }
    
    
    @Test
    public void testCompareByRating6() {
        Photograph b = new Photograph("mypic3.jpg", "A great photo!", "2018-01-13", 2);
        Photograph c = new Photograph("mypic3.jpg", "Grand Canyon 3", "2018-01-13", 2);
        assertTrue("CompareByRating compare() didn't compare photos properly by caption if rating equal", byRating.compare(b,c) < 0);
        assertTrue("CompareByRating compare() didn't compare photos properly by caption if rating equal", byRating.compare(c,b) > 0);
    }
    
    @Test
    public void testCompareByCaption() {
        Photograph b = new Photograph("mypic3.jpg", "Grand Canyon 3", "2019-02-13", 3);
        Photograph c = new Photograph("mypic3.jpg", "Grand Canyon 3", "2019-02-13", 3);
        assertEquals("CompareByCaption compare() didn't say two photos were equal (return 0)", 0, byCaption.compare(b,b));
        assertEquals("CompareByCaption compare() didn't say two photos were equal (return 0)", 0, byCaption.compare(b,c));
    }
    
    @Test
    public void testCompareByCaption2() {
        Photograph b = new Photograph("mypic3.jpg", "Albequerque", "2018-02-03", 5);
        Photograph c = new Photograph("mypic3.jpg", "Grand Canyon 3", "2019-02-13", 2);
        assertTrue("CompareByCaption compare() didn't compare photos properly by caption", byCaption.compare(b,c) < 0);
        assertTrue("CompareByCaption compare() didn't compare photos properly by caption", byCaption.compare(c,b) > 0);
    }
    
    @Test
    public void testCompareByCaption3() {
        Photograph b = new Photograph("mypic3.jpg", "Grand Canyon 2", "2017-12-13", 1);
        Photograph c = new Photograph("mypic3.jpg", "Grand Canyon 3", "2018-02-13", 0);
        assertTrue("CompareByCaption compare() didn't compare photos properly by caption", byCaption.compare(b,c) < 0);
        assertTrue("CompareByCaption compare() didn't compare photos properly by caption", byCaption.compare(c,b) > 0);
    }
    
    @Test
    public void testCompareByCaption5() {
        Photograph b = new Photograph("mypic3.jpg", "Grand Canyon 3", "2018-01-11", 5);
        Photograph c = new Photograph("mypic3.jpg", "Grand Canyon 3", "2018-01-11", 2);
        assertTrue("CompareByCaption compare() didn't compare photos properly by rating if caption equal", byCaption.compare(b,c) < 0);
        assertTrue("CompareByCaption compare() didn't compare photos properly by rating if caption equal", byCaption.compare(c,b) > 0);
    }
    
    
    @Test
    public void testCompareByCaption6() {
        Photograph b = new Photograph("mypic3.jpg", "Grand Canyon 3", "2018-01-13", 2);
        Photograph c = new Photograph("mypic3.jpg", "Grand Canyon 3", "2018-05-13", 0);
        assertTrue("CompareByCaption compare() didn't compare photos properly by rating if caption equal", byCaption.compare(b,c) < 0);
        assertTrue("CompareByCaption compare() didn't compare photos properly by rating if caption equal", byCaption.compare(c,b) > 0);
    }
}
